#pragma once

typedef void (*InstructionFunc)(unsigned char *data);

#define InstructionFuncType(a) void a(unsigned char *data)

/* 00 */ InstructionFuncType(Halt);
/* 01 */ InstructionFuncType(Move_MemImm);
/* 02 */ InstructionFuncType(Move_MemMem);
/* 03 */ InstructionFuncType(Add_MemImm);
/* 04 */ InstructionFuncType(Add_MemMem);
/* 05 */ InstructionFuncType(And_MemImm);
/* 06 */ InstructionFuncType(And_MemMem);
/* 07 */ InstructionFuncType(Or_MemImm);
/* 08 */ InstructionFuncType(Or_MemMem);
/* 09 */ InstructionFuncType(Xor_MemImm);
/* 0A */ InstructionFuncType(Xor_MemMem);
/* 0B */ InstructionFuncType(Shl_MemImm);
/* 0C */ InstructionFuncType(Shr_MemImm);
/* 0D */ InstructionFuncType(Goto_Mem);
/* 0E */ InstructionFuncType(Goto_Imm);
/* 0F */ InstructionFuncType(Neg_Mem);
/* 10 */ InstructionFuncType(MovePtrFrom_MemMem);
/* 11 */ InstructionFuncType(MovePtrTo_MemMem);
/* 12 */ InstructionFuncType(GotoEqual_ImmMemMem);
/* 13 */ InstructionFuncType(GotoLess_ImmMemMem);
/* 14 */ InstructionFuncType(BlockInt);
/* 15 */ InstructionFuncType(ReleaseInt);
// SESESE
/* 16 */ InstructionFuncType(SIMDMove_MemMemMem); // Dst Src DWORD_Count
/* 17 */ InstructionFuncType(SIMDAdd_MemMemMem);  // Dst Src DWORD_Count
/* 18 */ InstructionFuncType(SIMDAnd_MemMemMem);  // Dst Src DWORD_Count
/* 19 */ InstructionFuncType(SIMDOr_MemMemMem);   // Dst Src DWORD_Count
/* 1A */ InstructionFuncType(SIMDXor_MemMemMem);  // Dst Src DWORD_Count
/* 1B */ InstructionFuncType(SIMDShl_MemImmMem);  // Dst/Src Shift DWORD_Count
/* 1C */ InstructionFuncType(SIMDShr_MemImmMem);  // Dst/Src Shift DWORD_Count
/* 1D */ InstructionFuncType(SIMDNeg_MemMem);     // Dst/Src DWORD_Count
/* 1E */ InstructionFuncType(SIMDCopy_MemMemMem); // Dst Src DWORD_Count
// SESESE2
/* 1F */ InstructionFuncType(SIMDAdd_MemImmMem);  // Dst/Src Imm DWORD_Count
/* 20 */ InstructionFuncType(SIMDAnd_MemImmMem);  // Dst/Src Imm DWORD_Count
/* 21 */ InstructionFuncType(SIMDOr_MemImmMem);   // Dst/Src Imm DWORD_Count
/* 22 */ InstructionFuncType(SIMDXor_MemImmMem);  // Dst/Src Imm DWORD_Count
/* 23 */ InstructionFuncType(SIMDSet_MemImmMem);  // Dst/Src Imm DWORD_Count

// Do not use SIMD instructions to set Timer1 and CursorHidden options in Special.

